%global gittag 6.1.0.202203080745-r

Summary:        A pure java implementation of git
Name:           jgit
Version:        6.1.0
Release:        2%{?dist}
License:        BSD
URL:            https://www.eclipse.org/jgit/
Source0:        https://git.eclipse.org/c/jgit/jgit.git/snapshot/jgit-%{gittag}.tar.xz

Patch3000: 0001-Ensure-the-correct-classpath-is-set-for-the-jgit-com.patch

BuildRequires: mvn(org.slf4j:slf4j-api) mvn(org.slf4j:slf4j-simple) mvn(org.tukaani:xz) >= 1.9 mvn(org.eclipse.jetty:jetty-servlet)
BuildRequires: mvn(org.codehaus.mojo:build-helper-maven-plugin) mvn(org.osgi:osgi.core) mvn(com.googlecode.javaewah:JavaEWAH)
BuildRequires: mvn(org.bouncycastle:bcpkix-jdk15on) >= 1.70 mvn(org.bouncycastle:bcprov-jdk15on) >= 1.70 mvn(org.bouncycastle:bcutil-jdk15on) >= 1.70
BuildRequires: mvn(org.bouncycastle:bcpg-jdk15on) >= 1.70 mvn(org.apache.sshd:sshd-sftp) >= 2.8.0 mvn(com.google.code.gson:gson)
BuildRequires: mvn(org.apache.httpcomponents:httpclient) mvn(org.apache.httpcomponents:httpcore) mvn(org.apache.maven.plugins:maven-antrun-plugin) mvn(org.apache.sshd:sshd-osgi) >= 2.8.0
BuildRequires: mvn(net.java.dev.jna:jna) mvn(net.java.dev.jna:jna-platform) mvn(org.apache.ant:ant) mvn(org.apache.commons:commons-compress)
BuildRequires: mvn(com.jcraft:jsch) mvn(com.jcraft:jzlib) mvn(javax.servlet:javax.servlet-api) mvn(net.i2p.crypto:eddsa)
BuildRequires: maven-local mvn(args4j:args4j)

Requires: apache-commons-logging jzlib
Requires: bouncycastle >= 1.70 apache-sshd >= 2.8.0

BuildArch: noarch
ExclusiveArch:  %{java_arches} noarch

%description
A pure Java implementation of the Git version control system and command
line interface.

%package javadoc
Summary:        API documentation for %{name}

%description javadoc
%{summary}.

%prep
%autosetup -p1 -n jgit-%{gittag}

rm .mvn/maven.config

%pom_xpath_remove "pom:configuration/pom:annotationProcessorPaths"
%pom_xpath_remove "pom:configuration/pom:compilerArgs"

%pom_change_dep -r org.osgi:org.osgi.core org.osgi:osgi.core:\${osgi-core-version}:provided

%pom_disable_module org.eclipse.jgit.coverage
%pom_disable_module org.eclipse.jgit.benchmarks
%pom_remove_plugin :jacoco-maven-plugin
%pom_remove_plugin :maven-javadoc-plugin
%pom_remove_plugin -r :maven-source-plugin
%pom_remove_plugin :maven-enforcer-plugin
%pom_remove_plugin -r :japicmp-maven-plugin

sed -i -e 's/@{argLine}//' $(find -name pom.xml)

%pom_remove_plugin org.codehaus.mojo:build-helper-maven-plugin org.eclipse.jgit.pgm
%pom_remove_plugin :spring-boot-maven-plugin org.eclipse.jgit.pgm
%pom_xpath_remove "pom:plugins/pom:plugin/pom:executions/pom:execution[pom:id='create_jgit']" org.eclipse.jgit.pgm
sed -i -e 's/org\.springframework\.boot\.loader\.JarLauncher/org.eclipse.jgit.pgm.Main/' \
  org.eclipse.jgit.pgm/jgit.sh

sed -i -e '/\.test<\/module>/d' pom.xml

%pom_disable_module org.eclipse.jgit.junit
%pom_disable_module org.eclipse.jgit.junit.ssh
%pom_disable_module org.eclipse.jgit.junit.http

%build
%mvn_build -f -- -Pjavac

%install
%mvn_install

install -dm 755 %{buildroot}%{_bindir}
install -m 755 org.eclipse.jgit.pgm/jgit.sh %{buildroot}%{_bindir}/jgit

install -dm 755 %{buildroot}%{_sysconfdir}/ant.d
cat > %{buildroot}%{_sysconfdir}/ant.d/jgit <<EOF
jgit/org.eclipse.jgit jgit/org.eclipse.jgit.ant slf4j/slf4j-api slf4j/slf4j-simple jzlib jsch commons-compress xz-java javaewah httpcomponents/httpcore httpcomponents/httpclient commons-logging commons-codec eddsa apache-sshd/sshd-osgi apache-sshd/sshd-sftp
EOF

%files -f .mfiles
%license LICENSE
%doc README.md
%{_bindir}/jgit
%config(noreplace) %{_sysconfdir}/ant.d/jgit

%files javadoc -f .mfiles-javadoc
%license LICENSE

%changelog
* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 6.1.0-2
- Rebuilt for OpenCloudOS Stream 23.05

* Tue Apr 25 2023 cunshunxia <cunshunxia@tencent.com> - 6.1.0-1
- initial build
